package gregapi.oredict;

import gregapi.code.ArrayListNoNulls;

/**
 * @author Gregorius Techneticies
 */
public class OreDictConfigurationComponent implements IOreDictConfigurationComponent {
	private final ArrayListNoNulls<OreDictMaterialStack> mList;
	public final long mCommonDivider;
	
	public OreDictConfigurationComponent(long aCommonDivider, OreDictMaterialStack... aComponents) {
		mList = new ArrayListNoNulls<OreDictMaterialStack>(false, aComponents);
		mCommonDivider = aCommonDivider;
	}
	
	@Override
	public ArrayListNoNulls<OreDictMaterialStack> getComponents() {
		return mList;
	}
	
	@Override
	public long getCommonDivider() {
		return mCommonDivider;
	}
}