package gregapi.worldgen;

import gregapi.old.GregTech_API;
import gregapi.oredict.OreDictMaterial;

import java.util.Random;

import net.minecraft.world.World;
import net.minecraft.world.chunk.IChunkProvider;

public class Worldgen_GT_Ore_SmallPieces extends WorldgenObject {
	public final short mMinY, mMaxY, mAmount, mMeta;
	public final boolean mOverworld, mNether, mEnd;
	
	public Worldgen_GT_Ore_SmallPieces(String aName, boolean aDefault, int aMinY, int aMaxY, int aAmount, boolean aOverworld, boolean aNether, boolean aEnd, OreDictMaterial aPrimary) {
		super(aName, Worldgenerator.sWorldgenList, aDefault);
		mOverworld			= GregTech_API.sWorldgenFile.get("worldgen."+mWorldGenName, "Overworld"				, aOverworld);
		mNether				= GregTech_API.sWorldgenFile.get("worldgen."+mWorldGenName, "Nether"				, aNether);
		mEnd				= GregTech_API.sWorldgenFile.get("worldgen."+mWorldGenName, "TheEnd"				, aEnd);
		mMinY				= (short)					GregTech_API.sWorldgenFile.get("worldgen."+mWorldGenName, "MinHeight"				, aMinY);
		mMaxY				= (short)Math.max(mMinY+1, 	GregTech_API.sWorldgenFile.get("worldgen."+mWorldGenName, "MaxHeight"				, aMaxY));
		mAmount				= (short)Math.max(1,		GregTech_API.sWorldgenFile.get("worldgen."+mWorldGenName, "Amount"					, aAmount));
		mMeta				= OreDictMaterial.get(		GregTech_API.sWorldgenFile.get("worldgen."+mWorldGenName, "Ore"						, aPrimary.mNameInternal)).mID;
	}
	
	@Override
	public boolean executeWorldgen(World aWorld, Random aRandom, String aBiome, int aDimensionType, int aChunkX, int aChunkZ, IChunkProvider aChunkGenerator, IChunkProvider aChunkProvider) {
		if (!isGenerationAllowed(aWorld, aDimensionType, (aDimensionType == -1 && mNether) || (aDimensionType == 0 && mOverworld) || (aDimensionType == +1 && mEnd) ? aDimensionType : ~aDimensionType)) return false;
		if (mMeta > 0) for (int i = 0, j = Math.max(1, mAmount/2 + aRandom.nextInt(mAmount)/2); i < j; i++) Worldgenerator.setSmallOreBlock(aWorld, aChunkX+aRandom.nextInt(16), mMinY+aRandom.nextInt(Math.max(1, mMaxY-mMinY)), aChunkZ+aRandom.nextInt(16), mMeta);
		return true;
	}
}